/usr/lib/update-notifier/package-data-downloader:OSError:process_download_requests:/usr/lib/update-notifier/package-data-downloader@305:process_download_requests:print_exc:print_exception

Bug #1640318 reported by errors.ubuntu.com bug bridge on 2016-11-08
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
update-notifier (Ubuntu)
High
Brian Murray
Xenial
High
Brian Murray
Yakkety
High
Brian Murray

Bug Description

Impact
------
Crash reports are being generated when update-notifier is trying to print a message which isn't really necessary to print. This crash its reporting process is wasting resources of users and the Error Tracker.

Test Case
---------
We haven't figure out exactly how the crash is happening but given the volume of errors which we are receiving we can verify it the crash is no longer occurring by checking the errors bucket in this bug report after a couple of weeks.

Regression Potential
--------------------
Its possible that there is something terrible causing stdout to disappear and that we are hiding that by no longer printing when it isn't there. However, there is insufficient information in the crash reports to sort out why its not available and we'd rather conserve resources by not causing the crashes.

Original Description
--------------------
The Ubuntu Error Tracker has been receiving reports about a problem regarding update-notifier. This problem was most recently seen with package version 3.172, the problem page at https://errors.ubuntu.com/problem/140b42227c613c32a42f8ad1d4537e8f3dd82dc2 contains more details, including versions of packages affected, stacktrace or traceback, and individual crash reports.
If you do not have access to the Ubuntu Error Tracker you can request it at http://forms.canonical.com/reports/.

Related branches

Brian Murray (brian-murray) wrote :

The Traceback:

Traceback (most recent call last):
  File "/usr/lib/update-notifier/package-data-downloader", line 240, in process_download_requests
    print("%s: downloading %s" % (relfile, files[i]))
OSError: [Errno 5] Input/output error

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/usr/lib/update-notifier/package-data-downloader", line 305, in <module>
    process_download_requests()
  File "/usr/lib/update-notifier/package-data-downloader", line 263, in process_download_requests
    traceback.print_exc(file=sys.stderr)
  File "/usr/lib/python3.5/traceback.py", line 159, in print_exc
    print_exception(*sys.exc_info(), limit=limit, file=file, chain=chain)
  File "/usr/lib/python3.5/traceback.py", line 101, in print_exception
    print(line, file=file, end="")
OSError: [Errno 5] Input/output error

There is also a similar one with the print("%s: processing...") line.

Changed in update-notifier (Ubuntu):
assignee: nobody → Brian Murray (brian-murray)
importance: Undecided → High
status: New → In Progress
Changed in update-notifier (Ubuntu Xenial):
importance: Undecided → High
Changed in update-notifier (Ubuntu Yakkety):
importance: Undecided → High
Changed in update-notifier (Ubuntu Xenial):
status: New → Triaged
Changed in update-notifier (Ubuntu Yakkety):
status: New → Triaged
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-notifier - 3.176

---------------
update-notifier (3.176) zesty; urgency=medium

  * data/package-data-downloader: Be resilient and do not crash when we can
    not print information about what is happening. (LP: #1640318)

 -- Brian Murray <email address hidden> Thu, 10 Nov 2016 13:29:27 -0800

Changed in update-notifier (Ubuntu):
status: In Progress → Fix Released
Changed in update-notifier (Ubuntu Xenial):
assignee: nobody → Brian Murray (brian-murray)
Changed in update-notifier (Ubuntu Yakkety):
assignee: nobody → Brian Murray (brian-murray)
Changed in update-notifier (Ubuntu Xenial):
status: Triaged → In Progress
Changed in update-notifier (Ubuntu Yakkety):
status: Triaged → In Progress
description: updated
Robie Basak (racb) wrote :

Looks good to accept into proposed, but:

<rbasak> bdmurray: for bug 1640318, why not use the errno module's symbolic constants rather than hardcoding a number everywhere? Also, that's a whole load of duplication - could that be in a "attempt_print" function or something?

14:26 <rbasak> bdmurray: That's more for the development release. I guess it probably doesn't matter too much for an SRU.

I'm still OK to accept this, but would you like the opportunity to change it first?

Robie Basak (racb) wrote :

Also, are errno values the same across all architectures? I think they are, but I thought I'd ask.

Martin Pitt (pitti) wrote :

+ except OSError as e:
+ if e.errno == 5:
+ pass

This check makes little sense -- if errno is 5 or something else, the exception is ignored in both cases. So just

   except OSError:
      pass

is sufficient IMHO -- after all, what else can you do, you can't even print a warning :-)

The upload that purportedly fixed this bug in release yakkety was not accepted into the -proposed repository for the following reason: Change should be updated to pass on all OSErrors..

Brian Murray (brian-murray) wrote :

The upload that purportedly fixed this bug in xenial was not accepted into the -proposed repository for the following reason: "Change should be updated to pass on all OSErrors.".

Brian Murray (brian-murray) wrote :

This has been reuploaded to the X and Y queues for the SRU team to review.

Hello errors.ubuntu.com, or anyone else affected,

Accepted update-notifier into yakkety-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-notifier/3.175.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in update-notifier (Ubuntu Yakkety):
status: In Progress → Fix Committed
tags: added: verification-needed
Changed in update-notifier (Ubuntu Xenial):
status: In Progress → Fix Committed
Timo Aaltonen (tjaalton) wrote :

Hello errors.ubuntu.com, or anyone else affected,

Accepted update-notifier into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-notifier/3.168.3 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Brian Murray (brian-murray) wrote :

The new package versions do not appear in any of the buckets listed in the bug report so I'm setting this to verification-done.

tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-notifier - 3.168.3

---------------
update-notifier (3.168.3) xenial; urgency=medium

  * data/package-data-downloader: Be resilient and do not crash when we can
    not print information about what is happening. (LP: #1640318)

 -- Brian Murray <email address hidden> Tue, 15 Nov 2016 16:49:47 -0800

Changed in update-notifier (Ubuntu Xenial):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for update-notifier has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-notifier - 3.175.1

---------------
update-notifier (3.175.1) yakkety; urgency=medium

  * data/package-data-downloader: Be resilient and do not crash when we can
    not print information about what is happening. (LP: #1640318)

 -- Brian Murray <email address hidden> Wed, 16 Nov 2016 12:36:42 -0800

Changed in update-notifier (Ubuntu Yakkety):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers